"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NativeListStyles = exports.Nested = exports.Default = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _OrderedList = _interopRequireDefault(require("../OrderedList"));

var _addonKnobs = require("@storybook/addon-knobs");

var _ListItem = _interopRequireDefault(require("../ListItem"));

var _OrderedList2 = _interopRequireDefault(require("./OrderedList.mdx"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var props = {
  regular: function regular() {
    return {
      isExpressive: (0, _addonKnobs.boolean)('Expressive', false)
    };
  }
};
var _default = {
  title: 'Components/OrderedList',
  decorators: [_addonKnobs.withKnobs],
  parameters: {
    component: _OrderedList.default,
    docs: {
      page: _OrderedList2.default
    },
    subcomponents: {
      ListItem: _ListItem.default
    }
  }
};
exports.default = _default;

var Default = function Default() {
  return /*#__PURE__*/_react.default.createElement(_OrderedList.default, null, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"));
};

exports.Default = Default;
Default.storyName = 'default';
Default.parameters = {
  info: {
    text: "Lists consist of related content grouped together and organized vertically. Ordered lists are used to present content in a numbered list."
  }
};

var Nested = function Nested() {
  var regularProps = props.regular();
  return /*#__PURE__*/_react.default.createElement(_OrderedList.default, regularProps, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1", /*#__PURE__*/_react.default.createElement(_OrderedList.default, {
    nested: true
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2", /*#__PURE__*/_react.default.createElement(_OrderedList.default, {
    nested: true
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 3"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 3"))))), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"));
};

exports.Nested = Nested;
Nested.storyName = 'nested';
Nested.parameters = {
  info: {
    text: "Lists consist of related content grouped together and organized vertically. Ordered lists are used to present content in a numbered list."
  }
};

var NativeListStyles = function NativeListStyles() {
  var regularProps = props.regular();
  return /*#__PURE__*/_react.default.createElement(_OrderedList.default, _extends({
    native: true
  }, regularProps), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1", /*#__PURE__*/_react.default.createElement(_OrderedList.default, {
    nested: true
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"))), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"));
};

exports.NativeListStyles = NativeListStyles;
Default.storyName = 'native styles';
NativeListStyles.parameters = {
  info: {
    text: "Lists consist of related content grouped together and organized vertically. Ordered lists are used to present content in a numbered list."
  }
};